#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <ogcsys.h>
#include <gccore.h>
#include <jpeg/jpgogc.h>

extern char picdata[];
extern int  piclength;

static u32 *xfb;
static GXRModeObj *rmode;

void display_jpeg(JPEGIMG jpeg, int x, int y) {
	
	unsigned int *jpegout = (unsigned int *) jpeg.outbuffer;
	
	int i,j;
	int height = jpeg.height;
	int width = jpeg.width / 2;
		for(i=0;i<=width;i++)
			for(j=0;j<=height-2;j++)
				xfb[(i+x)+320*(j+16+y)]=jpegout[i+width*j];
	
	//free(jpeg.outbuffer);
	
}


void Initialise() {
	
	VIDEO_Init();
	PAD_Init();
	
	rmode = VIDEO_GetPreferredMode(NULL);
	
	xfb = MEM_K0_TO_K1(SYS_AllocateFramebuffer(rmode));
	console_init(xfb,20,20,rmode->fbWidth,rmode->xfbHeight,rmode->fbWidth*VI_DISPLAY_PIX_SZ);
	
	VIDEO_Configure(rmode);
	VIDEO_SetNextFramebuffer(xfb);
	VIDEO_SetBlack(FALSE);
	VIDEO_Flush();
	VIDEO_WaitVSync();
	if(rmode->viTVMode&VI_NON_INTERLACE) VIDEO_WaitVSync();
}

void DrawHLine (int x1, int x2, int y, int color) {
	int i;
	y = 320 * y;
	x1 >>= 1;
	x2 >>= 1;
	for (i = x1; i <= x2; i++) {
		u32 *tmpfb = xfb;
		tmpfb[y+i] = color;
	}
}

void DrawVLine (int x, int y1, int y2, int color) {
	int i;
	x >>= 1;
	for (i = y1; i <= y2; i++) {
		u32 *tmpfb = xfb;
		tmpfb[x + (640 * i) / 2] = color;
	}
}

void DrawBox (int x1, int y1, int x2, int y2, int color) {
	DrawHLine (x1, x2, y1, color);
	DrawHLine (x1, x2, y2, color);
	DrawVLine (x1, y1, y2, color);
	DrawVLine (x2, y1, y2, color);
}


int main() {
	
	JPEGIMG about;
	
	memset(&about, 0, sizeof(JPEGIMG));
	
	about.inbuffer = picdata;
	about.inbufferlength = piclength;
	
	JPEG_Decompress(&about);
	
	Initialise();
	
	int cursor_x = 100;
	int cursor_y = 100;

	while(1) {
		
		VIDEO_ClearFrameBuffer (rmode, xfb, COLOR_BLACK);
		
		PAD_ScanPads();
		
		if (PAD_StickY(0) > 18) {
			cursor_y--;
		}
		if (PAD_StickY(0) < -18) {
			cursor_y++;
		}
		if (PAD_StickX(0) > 18) {
			cursor_x++;
		}
		if (PAD_StickX(0) < -18) {
			cursor_x--;
		}
		
		display_jpeg(about, 100, 100);
		
		DrawBox (cursor_x, cursor_y, cursor_x + 1, cursor_y + 1, COLOR_WHITE);
		
		VIDEO_WaitVSync();
		
	}
	
	
	return 0;
}
